/* frame.c */

#include <stdlib.h>
#include <string.h>
#include "specto.h"
#include "frame.h"

#ifdef MGW
#define _strdup strdup
#endif /* MGW */

int open_sdf();
int guess_file_type();
void close_sdf();

int     nfr = 0;
FRAME   fr_[MAXNFR] = {0};


/* newframe - begin new frame */

void
newframe()
{
    if (nfr < MAXNFR) {
        fr_[nfr].ix_min = ucon_.strtpos;
	fr_[nfr].iy_min = ucon_.ysp1;
	fr_[nfr].ix_max = ucon_.strtpos + ucon_.framelength;
        fr_[nfr].iy_max = ucon_.ysp1 + ucon_.ysp2;
	fr_[nfr].iw_min = ucon_.ywv1;
        fr_[nfr].iw_max = ucon_.ywv1 + ucon_.ywv2;
	fr_[nfr].fa_typ = ucon_.faty;
	fr_[nfr].ta_min = ucon_.tmn;
	fr_[nfr].ta_max = ucon_.tmx;
	fr_[nfr].fa_min = ucon_.fmn;
	fr_[nfr].fa_max = ucon_.fmx;
	fr_[nfr].fa_nat = ucon_.fnat;
	fr_[nfr].fa_pma = ucon_.fpma;
	fr_[nfr].fa_pmb = ucon_.fpmb;
	fr_[nfr].fa_pmc = ucon_.fpmc;
	fr_[nfr].wn_nft = ucon_.nfft;
	fr_[nfr].wn_wid = ucon_.winwid;
	fr_[nfr].wv_sps = wave_.sampsc;
#ifdef INFO
	fr_[nfr].sd_fn = _strdup(wave_.sdfn);
#endif /* INFO */
	nfr++;
    }
}

void
iniframe()
{
    while (nfr > 0)
	free(fr_[--nfr].sd_fn);
}

void
endframe(double mxm)
{
    fr_[nfr - 1].sm_max = (float) mxm;
}

#ifdef INFO
double spcval();
extern int (*fetch) ();

static  char last_fn[80] = {0};

int
wave_value(fn, t, r)
char *fn;
double t, r;
{
    int     ft, iv;
    long    is;

    if (fn == NULL || *fn == '\0' || fetch == NULL)
	return (0);
    if (strcmp(fn, last_fn) != 0) {
        if (last_fn[0] != '\0')
            close_sdf();
        wave_.sampsc = (float) r;
        strcpy(wave_.sdfn, fn);
        ft = guess_file_type(fn, 1);
        if (!open_sdf(ft)) {
            last_fn[0] = '\0';
            return (0);
        }
        strcpy(last_fn, fn);
    }
    is = (long) (t * r + 0.5);
    iv = (*fetch) (is);
    return (iv);
}

double
spec_value(char *fn, double t, double f, double r, int w, int n)
{
    double  v, p;
    int     ft;
    long    is;

    if (fn == NULL || *fn == '\0')
	return (0.0);
    if (strcmp(fn, last_fn) != 0) {
        if (last_fn[0] != '\0')
            close_sdf();
        wave_.sampsc = (float) r;
        ucon_.winwid = w;
        ucon_.nfft = n;
        strcpy(wave_.sdfn, fn);
        ft = guess_file_type(fn, 1);
        if (!open_sdf(ft)) {
            last_fn[0] = '\0';
            return (0);
        }
        strcpy(last_fn, fn);
    }
    is = (long) (t * r + 0.5);
    p = n * f / r;
    v = spcval(is, p);
    return (v);
}

void
reset_value()
{
    if (last_fn[0] != '\0')
	close_sdf();
    last_fn[0] = '\0';
}

#endif /* INFO */
