/* nw.c - generated from nw.psw */

#include <dpsclient/dpsfriends.h>
#include <string.h>

#line 1 "nw.psw"

#include <stdio.h>
#include <dpsclient/dpsclient.h>
#include <appkit/graphics.h>

#define	beep()	{fputc('\007', stderr);fflush(stderr);}

char   *calloc();
char   *getenv();
void    co_setup(), co_idle(), co_page(), co_out(), co_end();
void    co_rule(), co_line();

extern void (*pr_idle) (), (*pr_page) (), (*pr_out) (), (*pr_end) ();
extern void (*pr_rule) (), (*pr_line) ();
extern FILE *lgf;
extern int adupi_x;
extern int adupi_y;
extern int pglen;
extern int pgwid;
extern int bpp;
extern int p_gmode;
extern float dotdiam;

static void Setup();
static void VStrip();
static void Rule();
static void Moveto();
static void Lineto();
static void Stroke();
static void CreatePage();
static void begin_page();
static void end_page();
static DPSTextProc dps_text();
static DPSErrorProc dps_error();

static int psdpi = 0;
static long xpos = 0;
static long xprn = 0;
static long yprn = 0;
static int firstprint = 1;
static int *ibuf;
static DPSContext context;

void
co_setup()
{
    if (getenv("Workspace") == NULL) {
	fprintf(stderr, "NeXT workspace isn't accessible, now.\n");
	exit(1);
    }
    psdpi = 92;
    adupi_x = psdpi;
    adupi_y = psdpi;
    pglen = psdpi * 11;
    pgwid = psdpi * 8.5;
    bpp = 1;
    dotdiam = 1.0 / psdpi;
    ibuf = (int *) calloc(pgwid, sizeof(int));

    pr_idle = co_idle;
    pr_page = co_page;
    pr_out = co_out;
    pr_end = co_end;
    pr_rule = co_rule;
    pr_line = co_line;
}

void
co_out(buf, n)
unsigned char *buf;
int     n;
{
    char  str[80];
    int i, j, nn;
    long ypos;

    if (firstprint) {
	Setup();
	firstprint = 0;
    }
    if (n > 0) {
	for (i = 0; i < n && buf[i] == 0; i++)
	    continue;
	ypos = i;
	nn = n - i;
	for (j = 0; j < nn; j++)
	    ibuf[j] = buf[j + i];
	VStrip(xpos, ypos, ibuf, nn);
    }
    xpos += 8;
}

void
co_end(prompt)
{
    end_page(prompt);
    DPSDestroyContext(context);
}

void
co_idle()
{
}

void
co_page()
{
    end_page(1);
    begin_page();
}


void
co_rule(xllc, yllc, xlen, ylen)
long xllc, yllc, xlen, ylen;
{
    if (firstprint) {
	Setup();
	firstprint = 0;
    }
    Rule(xllc, yllc, xlen, ylen);
}

void
co_line(n, x, y, w)
int n;
long *x, *y;
double w;
{
    int  i, nc;
    char str[80];

    if (n < 2)
	return;
    if (firstprint) {
	Setup();
	firstprint = 0;
    }
    Moveto(x[0] - xprn, y[0] - yprn);
    for (i = 1; i < n; i++) {
	Lineto(x[i] - x[i - 1], y[i] - y[i - 1]);
    }
    Stroke(w);
}

static void
begin_page()
{
    DPSclippath(context);
    DPSsetgray(context, 1.0);
    DPSfill(context);
    DPSsetgray(context, 0.0);
}

static void
end_page(prompt)
{
    NXEvent event;

    DPSflushgraphics(context);
    DPSWaitContext(context);
    if (prompt && xpos > 0) {
	beep();
	xpos = 0;
	DPSPrintf(context, "%d currentwindow seteventmask\n",
	    NX_KEYDOWNMASK + NX_LMOUSEDOWNMASK + NX_RMOUSEDOWNMASK);
	for (;;) {
	    DPSFlushContext(context);
	    DPSGetEvent(context, &event, -1, NX_FOREVER, 0);
	    if (event.type == NX_RMOUSEDOWN) {
		break;
	    } else if (event.type == NX_LMOUSEDOWN) {
		DPSPrintf(context,
		    "1 0 %d orderwindow\n"
		    "{%d stilldown not {exit} if\n"
		    "deskWin currentmouse %g sub exch %g sub exch\n"
		    "%d movewindow} loop\n",
		    event.window,event.data.mouse.eventNum,
		    event.location.y, event.location.x, event.window);
	    } else if (event.type == NX_KEYDOWN) {
		if (event.data.key.charCode == '\r')
		    break;
		if (event.data.key.charCode == '\003')	/* ^C */
		    kill();
	    }
	}
	DPSPrintf(context, "%d currentwindow seteventmask\n",
	    NX_LMOUSEDOWNMASK + NX_RMOUSEDOWNMASK);
    }
}

static void
Setup()
{
    float   x, y, w, h;
    static float   dpi = 92.0;
    static float   margin = 0.25;

    context = DPSCreateContext(NULL, NULL, (DPSTextProc) dps_text,
	(DPSErrorProc) dps_error);
    w = 11.0 * dpi;
    h = 8.5 * dpi;
    x = (1120 - w) / 2;
    y = (832 - h) / 2;
    CreatePage(x, y, w, h);
    DPSSetContext(context);
    DPSWaitContext(context);
}

static  DPSTextProc
dps_text(context, buffer, count)
DPSContext context;
char   *buffer;
long unsigned int count;
{
    fwrite(buffer, 1, count, stderr);
    fflush(stderr);
}

static  DPSErrorProc
dps_error(cntxt, err, arg1, arg2)
DPSContext cntxt;
DPSErrorCode err;
long unsigned int arg1, arg2;
{
    fprintf(stderr, "DPS ERROR: %d  (%ld, %ld)\n", arg1, arg2);
}

/*======================= pswrap =============*/
#line 230 "nw.c"
void CreatePage(x, y, w, h)
float x, y, w, h; 
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjReal obj0;
    DPSBinObjReal obj1;
    DPSBinObjReal obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjReal obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    DPSBinObjGeneric obj8;
    DPSBinObjGeneric obj9;
    DPSBinObjGeneric obj10;
    DPSBinObjGeneric obj11;
    DPSBinObjGeneric obj12;
    DPSBinObjGeneric obj13;
    DPSBinObjGeneric obj14;
    DPSBinObjGeneric obj15;
    DPSBinObjGeneric obj16;
    DPSBinObjReal obj17;
    DPSBinObjReal obj18;
    DPSBinObjGeneric obj19;
    DPSBinObjGeneric obj20;
    DPSBinObjGeneric obj21;
    DPSBinObjReal obj22;
    DPSBinObjGeneric obj23;
    DPSBinObjGeneric obj24;
    DPSBinObjReal obj25;
    DPSBinObjGeneric obj26;
    DPSBinObjGeneric obj27;
    DPSBinObjGeneric obj28;
    DPSBinObjGeneric obj29;
    DPSBinObjGeneric obj30;
    DPSBinObjGeneric obj31;
    DPSBinObjGeneric obj32;
    DPSBinObjGeneric obj33;
    char obj34[13];
    char obj35[11];
    char obj36[13];
    char obj37[5];
    char obj38[17];
    char obj39[6];
    char obj40[8];
    } _dpsQ;
  static _dpsQ _dpsF = {
    DPS_DEF_TOKENTYPE, 34, 349,
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 1},	/* add */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: h */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 1},	/* add */
    {DPS_EXEC|DPS_NAME, 0, 8, 337},	/* Buffered */
    {DPS_EXEC|DPS_NAME, 0, 6, 331},	/* window */
    {DPS_EXEC|DPS_NAME, 0, 17, 314},	/* windowdeviceround */
    {DPS_EXEC|DPS_NAME, 0, 5, 309},	/* Above */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, 13, 296},	/* currentwindow */
    {DPS_EXEC|DPS_NAME, 0, 11, 285},	/* orderwindow */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: h */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 129},	/* rectstroke */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 169},	/* sub */
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: h */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 169},	/* sub */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 127},	/* rectclip */
    {DPS_EXEC|DPS_NAME, 0, 13, 272},	/* flushgraphics */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 154},	/* setlinejoin */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 153},	/* setlinecap */
    {'f','l','u','s','h','g','r','a','p','h','i','c','s'},
    {'o','r','d','e','r','w','i','n','d','o','w'},
    {'c','u','r','r','e','n','t','w','i','n','d','o','w'},
    {'A','b','o','v','e'},
    {'w','i','n','d','o','w','d','e','v','i','c','e','r','o','u','n','d'},
    {'w','i','n','d','o','w'},
    {'B','u','f','f','e','r','e','d'},
    }; /* _dpsQ */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;

  _dpsP[0].val.realVal = x;
  _dpsP[1].val.realVal = y;
  _dpsP[2].val.realVal =
  _dpsP[17].val.realVal =
  _dpsP[22].val.realVal = w;
  _dpsP[5].val.realVal =
  _dpsP[18].val.realVal =
  _dpsP[25].val.realVal = h;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,349);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 233 "nw.psw"

#line 342 "nw.c"
void Lineto(x, y)
long int x, y; 
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    } _dpsQ;
  static _dpsQ _dpsF = {
    DPS_DEF_TOKENTYPE, 3, 28,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 133},	/* rlineto */
    }; /* _dpsQ */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;

  _dpsP[0].val.integerVal = x;
  _dpsP[1].val.integerVal = y;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,28);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 237 "nw.psw"

#line 372 "nw.c"
void Moveto(x, y)
long int x, y; 
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    } _dpsQ;
  static _dpsQ _dpsF = {
    DPS_DEF_TOKENTYPE, 3, 28,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 107},	/* moveto */
    }; /* _dpsQ */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;

  _dpsP[0].val.integerVal = x;
  _dpsP[1].val.integerVal = y;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,28);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 241 "nw.psw"

#line 402 "nw.c"
void Stroke(w)
float w; 
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjReal obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    char obj4[13];
    } _dpsQ;
  static _dpsQ _dpsF = {
    DPS_DEF_TOKENTYPE, 4, 49,
    {DPS_LITERAL|DPS_REAL, 0, 0, 0},	/* param: w */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 155},	/* setlinewidth */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 167},	/* stroke */
    {DPS_EXEC|DPS_NAME, 0, 13, 32},	/* flushgraphics */
    {'f','l','u','s','h','g','r','a','p','h','i','c','s'},
    }; /* _dpsQ */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;

  _dpsP[0].val.realVal = w;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,49);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 247 "nw.psw"

#line 435 "nw.c"
void Rule(x, y, w, h)
long int x, y, w, h; 
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    char obj8[13];
    } _dpsQ;
  static _dpsQ _dpsF = {
    DPS_DEF_TOKENTYPE, 8, 81,
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 150},	/* setgray */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: w */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: h */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 128},	/* rectfill */
    {DPS_EXEC|DPS_NAME, 0, 13, 64},	/* flushgraphics */
    {'f','l','u','s','h','g','r','a','p','h','i','c','s'},
    }; /* _dpsQ */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;

  _dpsP[2].val.integerVal = x;
  _dpsP[3].val.integerVal = y;
  _dpsP[4].val.integerVal = w;
  _dpsP[5].val.integerVal = h;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,81);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 253 "nw.psw"

#line 479 "nw.c"
void VStrip(x, y, buf, n)
long int x, y; int buf[], n; 
{
  typedef struct {
    unsigned char tokenType;
    unsigned char topLevelCount;
    unsigned short nBytes;

    DPSBinObjGeneric obj0;
    DPSBinObjGeneric obj1;
    DPSBinObjGeneric obj2;
    DPSBinObjGeneric obj3;
    DPSBinObjGeneric obj4;
    DPSBinObjGeneric obj5;
    DPSBinObjGeneric obj6;
    DPSBinObjGeneric obj7;
    DPSBinObjGeneric obj8;
    DPSBinObjGeneric obj9;
    DPSBinObjGeneric obj10;
    DPSBinObjGeneric obj11;
    DPSBinObjGeneric obj12;
    DPSBinObjGeneric obj13;
    DPSBinObjGeneric obj14;
    DPSBinObjGeneric obj15;
    DPSBinObjGeneric obj16;
    DPSBinObjGeneric obj17;
    DPSBinObjGeneric obj18;
    DPSBinObjGeneric obj19;
    DPSBinObjGeneric obj20;
    DPSBinObjGeneric obj21;
    DPSBinObjGeneric obj22;
    DPSBinObjGeneric obj23;
    DPSBinObjGeneric obj24;
    DPSBinObjGeneric obj25;
    DPSBinObjGeneric obj26;
    DPSBinObjGeneric obj27;
    DPSBinObjGeneric obj28;
    DPSBinObjGeneric obj29;
    DPSBinObjGeneric obj30;
    DPSBinObjGeneric obj31;
    DPSBinObjGeneric obj32;
    DPSBinObjGeneric obj33;
    DPSBinObjGeneric obj34;
    } _dpsQ;

  typedef struct {
    char obj35[13];
    } _dpsQ1;
  static _dpsQ _dpsF = {
    DPS_DEF_TOKENTYPE, 27, 297,
    {DPS_LITERAL|DPS_NAME, 0, DPSSYSNAME, 394},	/* S */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: n */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 165},	/* string */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 51},	/* def */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: n */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 169},	/* sub */
    {DPS_EXEC|DPS_ARRAY, 0, 7, 224},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 72},	/* for */
    {DPS_LITERAL|DPS_INT, 0, 0, 8},
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: n */
    {DPS_LITERAL|DPS_BOOL, 0, 0, 1},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 260},	/* [ */
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 0},
    {DPS_LITERAL|DPS_INT, 0, 0, 1},
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: x */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 110},	/* neg */
    {DPS_LITERAL|DPS_INT, 0, 0, 0},	/* param: y */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 110},	/* neg */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 261},	/* ] */
    {DPS_EXEC|DPS_ARRAY, 0, 1, 216},
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 87},	/* imagemask */
    {DPS_EXEC|DPS_NAME, 0, 13, 280},	/* flushgraphics */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 394},	/* S */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 394},	/* S */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 62},	/* exch */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 56},	/* dup */
    {DPS_LITERAL|DPS_ARRAY, 0, 0, 280},	/* param[var]: buf */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 62},	/* exch */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 75},	/* get */
    {DPS_EXEC|DPS_NAME, 0, DPSSYSNAME, 120},	/* put */
    }; /* _dpsQ */
  static _dpsQ1 _dpsF1 = {
    {'f','l','u','s','h','g','r','a','p','h','i','c','s'},
    }; /* _dpsQ1 */
  register DPSContext _dpsCurCtxt = DPSPrivCurrentContext();
  char pad[3];
  register DPSBinObjRec *_dpsP = (DPSBinObjRec *)&_dpsF.obj0;
  register int _dps_offset = 280;

  _dpsP[19].val.integerVal = x;
  _dpsP[21].val.integerVal = y;
  _dpsP[31].length = n;
  _dpsP[1].val.integerVal =
  _dpsP[6].val.integerVal =
  _dpsP[12].val.integerVal = n;
  _dpsP[31].val.arrayVal = _dps_offset;
  _dps_offset += n * sizeof(DPSBinObjGeneric);
  _dpsP[26].val.stringVal = _dps_offset;
  _dps_offset += 13;

  _dpsF.nBytes = _dps_offset+4;
  DPSBinObjSeqWrite(_dpsCurCtxt,(char *) &_dpsF,284);
  DPSWriteTypedObjectArray(_dpsCurCtxt, dps_tInt, (char *)buf, n);
  DPSWriteStringChars(_dpsCurCtxt,(char *) &_dpsF1,13);
  if (0) *pad = 0;    /* quiets compiler warnings */
}
#line 261 "nw.psw"
